#define MAXCOLOR256

#include "wingraph.h"

//   PCX
typedef struct TPCXHeaderStruct
{
  unsigned char ID;
  unsigned char Version;
  unsigned char Coding;
  unsigned char BitPerPixel;
  unsigned short XMin;
  unsigned short YMin;
  unsigned short XMax;
  unsigned short YMax;
  unsigned short HRes;
  unsigned short VRes;
  unsigned char Palette[48];
  unsigned char Reserved;
  unsigned char Planes;
  unsigned short BytePerLine;
  unsigned short PaletteInfo;
  unsigned short HScreenSize;
  unsigned short VScreenSize;
  unsigned char Filler[54];
} TPCXHeader;

typedef struct TPaletteStruct
{
  unsigned char Red;
  unsigned char Green;
  unsigned char Blue;
} TPalette;

void main()
{
  resize(800, 600);
  FILE *f;
//  f = fopen("_Carib256.pcx", "rb");
  f = fopen("CAT256.PCX", "rb");
  TPalette palitra[256];
  fseek(f, -256 * 3, SEEK_END);
  fread(palitra, sizeof(palitra), 1, f); //  
  for (int i = 0; i < 256; i++) //  
    setpalette(i, RGB(palitra[i].Red, palitra[i].Green, palitra[i].Blue));
  fseek(f, 0, SEEK_SET);
  TPCXHeader header;
  fread(&header, sizeof(header), 1, f); //  
  int xSize = header.XMax - header.XMin + 1;
  int ySize = header.YMax - header.YMin + 1;
  /* ,        
     .    Planes = 1 */
  int totalBytes = header.Planes * header.BytePerLine;
  byte b, t;
  for (int i = 0; i < ySize; i++) {
    int j = 0;
    while (j < totalBytes) {
      fread(&b, 1, 1, f); //     
      t = b & 0xC0;
      if (t == 0xC0) { // ,  2   11
        /*   2 .  6  ,  
                 */
        t = b & 0x3F;
        fread(&b, 1, 1, f); //   
        for (int k = 0; k < t; k++) { //    t 
          if (j < xSize) //        
            putpixel(j, i, b);
          j++;
        }
      }
      else { //    
        if (j < xSize)
          putpixel(j, i, b);
        j++;
      }
    }
  }
  fclose(f);
}

